#!/usr/bin/perl
# Replace the above with the path to Perl on your system, as in newspro.cgi

# kTalk - NewsPro talkback addon

# Set the path to ktconfig.pl
# If it's in the same directory as ktalkpost.cgi, you may be able to leave
# this as is. If it is in another directory, or if you run into problems,
# change this to the absolute path to ktconfig.pl.
$ktconfigpath = 'ktconfig.pl';


# ------- NO EDITING REQUIRED BELOW ------

require $ktconfigpath;

read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);

foreach $pair (@pairs) {
($name, $value) = split(/=/, $pair);
   $value =~ tr/+/ /;
   $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
   $value =~ s/&/&amp;/g;
   $value =~ s/"/&quot;/g;
   $value =~ s/</&lt;/g;
   $value =~ s/>/&gt;/g;
	$FORM{$name} = $value;
}

$basedir = $talkdir;

# Reading the template
open(INFILE,"<$reponsetmpl");
@templatePage=<INFILE>;
close(INFILE);

#condense page array into one scalar variable
$resultPage=join('',@templatePage);

#Getting a nice filename
my $ktalkfilename = $FORM{newsID}; #Assuming submitted fields are in
$ktalkfilename =~ s/[^0-9\,]//g; # Strip out anything other than number or comma from the news ID
$ktalkfilename .= $talkext; # Add .shtml to the end.

# opens the diskussion file Reads it into a array
open(INF,"$basedir/$ktalkfilename") or &dienice("Can't open $basedir/$ktalkfilename");
   @ary = <INF>;
close(INF);

if ($FORM{'comment'}) {
	open(NEWFILE,">$basedir/$ktalkfilename") || &dienice("Can't open $basedir/$ktalkfilename for writing.");

	foreach $line (@ary) {
		chomp($line);

		if ($line =~ /<!--ktalk postnum:(\d+)-->/) {
			$postnum = $1;
			$postnum++;
			$line =~ s/<!--ktalk postnum:\d+-->/<!--ktalk postnum:$postnum-->/;
		}


		#Here we insert the new comment
		if ($line =~ /\Q<!--ktalk newpost-->\E/){
			#Substitute all the variables
			$resultPage =~ s/\Q<!--ktalk newpost-->\E//g; # compatability with older versions
			$resultPage =~ s/<!--INSTRUCTIONS[\s\S]+?END INSTRUCTIONS-->//g; # in case people leave the instruction comment in
			$resultPage =~ s/<!--ktalk field email-->/$FORM{'email'}/g;
			$resultPage =~ s/<!--ktalk field name-->/$FORM{'name'}/g;
			$FORM{'comment'} =~ s/\n/<br>/g;
			$resultPage =~ s/<!--ktalk field comment-->/<!--ktalk start_fields: start_email $FORM{'email'} end_email start_name $FORM{'name'} end_name end_fields--><!--ktalk start_comment-->$FORM{'comment'}<!--ktalk end_comment-->/g;
			# Generate a random ID.
			my $rando = int(rand(999999));
			my $commentID = $rando . "-" . time;
			unless ($ktPostOrder) {
				print NEWFILE "<!--ktalk newpost-->\n";
			}
			print NEWFILE "<!--ktalk start_item $commentID -->";
			print NEWFILE $resultPage;
			print NEWFILE "<!--ktalk end_item $commentID -->";
			if ($ktPostOrder) {
				print NEWFILE "\n<!--ktalk newpost-->\n";
			}
		}
		else {
			print NEWFILE "$line\n";
		}
	}
	close(NEWFILE);
}




# Reading the template

open(INFILE,"<$confirmtmpl") or &dienice("Can't open $confirmtmpl");
@confirmtmpl=<INFILE>;
close(INFILE);


print "Content-type:text/html\n\n";

# Build news if required.
if ($BuildOnPost) {
	$JustLoadSubs = 1;
	$SilentBuild = 1;
	require "$NPdir/newspro.cgi";
	$abspath = $NPdir;
	StartUp();
	ReadConfigInfo();
	LoadAddons();
	GenHTML();
}


#condense page array into one scalar variable
$result = join('', @confirmtmpl);
$result =~ s/<!--ktalk pageURL-->/$talkbaseurl\/$ktalkfilename/gi;
print $result;



sub dienice {
    print "Content-type:text/html\n\n";
    ($errmsg) = @_;
    print "<h2>Error</h2>\n";
    print "$errmsg<p>\n";
    print "Contact the server administrator if this problem persists.";
    print "</body></html>\n";
    exit;
}
